/*
 * Copyright (c) 4eachother.
 * Lindenstrasse 22, 14789 Bensdorf
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information of 4eachother.
 * You shall not disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with 4eachother.
 */
package test.async;

import javax.annotation.security.PermitAll;
import javax.ejb.EJB;
import javax.ejb.LocalBean;
import javax.ejb.Singleton;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.event.TransactionPhase;

/**
 *
 * @author jan
 */
@Singleton
public class MyActor {

   
    @TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
    @PermitAll
    public void finishJob(
            @MyEvent
            @Observes(notifyObserver = Reception.ALWAYS,
            during = TransactionPhase.AFTER_SUCCESS)
            final String uuid) {

        System.out.println("FINISH");
    }

    public void failJob(
            @MyEvent
            @Observes(notifyObserver = Reception.ALWAYS,
            during = TransactionPhase.AFTER_FAILURE)
            final String uuid) {

        System.out.println("FAIL");
    }
}
